'FFSubmenu=Rahmen
'FFName=MFDL-Rahmen sortieren / hinzufgen

'(c) Harald Maeckler, Dsseldorf 2006 - 2016

' ********************************************************************
'Script MFDL_Sort.vbs zum Sortieren der FF-Rahmendatei MFDL.cfg	und
'					  zum Hinzufgen anderer Rahmen aus einer 2. Datei
'
'Version 3.01 / 28.03.2016 - Skript-URL gem Forenberarbeitung gendert
'Version 3.00 / 07.08.2012 - Sortierroutine komplett erneuert (sehr viel schneller)
'						   - beim Sortieren Gro- wie Kleinschreibung behandeln
'						   - beim Sortieren , , , , ,  behandeln wie Ae, Oe, Ue, ae, oe, ue
'						   - Hinzufgen jetzt ohne Kontrolle ob bereits vorhanden
'						   - Updatefunktion hinzugefgt
'Version 2.03 / 10.07.2009 - Lschroutine hinzugefgt und KB entsprechend ergnzt
'Version 2.02 / 11.08.2007 - Skript verschlankt
'Version 2.01 / 09.08.2007 - Kleine Bugs eliminiert	und
'							 Funktion BrowseForFile ersetzt durch FF_EnterFileName
'Version 2.00 / 08.08.2007 - Erweiterung um Hinzufgen aus 2. Datei
'Version 1.06 / 06.04.2007 - Pfadanpasuung fr Version 2.84 ab B86
'Version 1.05 / 12.12.2006 - Leerzeilen werden gelscht

'** Start Kurzbeschreibung *******************************************
' MFDLSort / Version 3.01
' ===============
'
' Sortieren
' -----------
' Die Rahmen werden in der Reihenfolge ihrer Entstehung angezeigt, was das Wiederauffinden sehr erschwert.
' Das Script MFDL_Sort ermglicht das alpanumerische Sortieren nach dem ASCII-Code. Dabei werden die Umlaute
' , , , ,  und  behandelt wie Ae, Oe, Ue, ae, oe und ue und Kleinschreibung wie Groschreibung.
'
' Die Sortierung erlaubt, die eigenen Favoriten oben in der Liste anzuordnen. Dazu speichert man sie mit einem 
' entsprechedem Vorspann ab, z.B. mit einem Leerzeichen gefolgt von 001-, 002-, 003- u.s.w.. Die ursprnglichen 
' Rahmen sollte man allerdings lschen, damit sie nicht doppelt vorliegen.
'
' Man kann natrlich auch die Rahmendatei MFDL.cfg im Sript-Verzeichnis des FixFoto-Programmverzeichnis direkt
' editieren. Dazu die Datei mit dem Editor ffnen und die mit # beginnenden Bezeichnungszeilen ndern. Aber
' Achtung, das Zeichen # muss erhalten bleiben.
'
' Vorsicht: In den Rahmennamen drfen auf keinen Fall die Zeichen @ oder \ verwendet werden.
'
' Hinzufgen
' --------------
' Man whlt eine zweite Datei mit MFDL-Rahmen aus, die beispielsweise auf einem anderen Rechner entstanden ist.
' Wenn die Option "Hinzufgen" aktiviert ist, werden die Rahmen aus dieser Datei der Standarddatei hinzugefgt.
' Ist auch 'Sortieren' aktiviert, werden anschlieend alle Rahmen sortiert.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine Lschroutine aufgerufen
' werden. Nach einer Sicherheitsabfrage wird berprft, ob das zugehrige zip-Archiv im Skriptordner abgelegt 
' ist. Wenn ja, wird vor dem Lschen angeboten, davon eine Sicherheitskopie an einem beliebigen Speicherort ab-
' zulegen. Danach werden nacheinander die Skriptdatei, die in der Registry dazugehrenden Daten und eventuelle
' Zusatzdateien gelscht. Abschlieend wird die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit allen Komponenten aus
' der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

const SkriptName = "MFDL_Sort.vbs"							'Skriptname
const RegSchluessel = "FF_MFDL_Sort"						'Regschlssel

Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
const ForReading = 1, ForWriting = 2, ForAppending = 8

Dim SkriptKill,Antwort,TempFile : SkriptKill = false		'Deinstallation

Dim UrListenArray,ListenArray,Ergebnis,Max					'Sortierung
const BZ = "#"	 	'Block-Trennzeichen fr die Datenstze
const EZ = "\"		'Ersatz fr Zeilenwechsel 'vbNewLine'
const TZ = "@"		'Trennzeichen zur Kennzeichnung von Umlauten

Dim Zieldatei												'Hinzufgen

'Updatekonstanten und Variable
const SkriptVersion = "3.01"
const SkriptURL = "http://www.ffsf.de/resources/mfdlsort.160/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'Festlegungen
Dim Quelldatei,BackUpDatei
Quelldatei = FF_GetScriptPath() & "\MFDL.cfg"
BackUpDatei = FF_GetScriptPath() & "\MFDL_Backup.cfg"
Dim flag_Sortieren,flag_Hinzu,RDatei2
Dim ZeitTest : ZeitTest = false			'true = Anzeige der Sortierzeit

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'-------------------------------------------------------------------------
call main
Set objFS = nothing
Set WshShell = nothing
'-------------------------------------------------------------------------
Sub main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if Err.Number > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if not objFS.FileExists(FF_GetScriptPath & "\" & SkriptName) then
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog MFDL-Rahmen **
FF_AddDialog "MFDL-Rahmen",116,94
FF_AddControl "MFDL-Rahmen","Sortierung","GROUP",5,5,106,22
FF_AddControl "MFDL-Rahmen","flag_Sortieren","BOOL",10,15,8,8
FF_AddControl "MFDL-Rahmen","alpahnumerisch sortieren","STATIC",22,14,65,10
FF_AddControl "MFDL-Rahmen","Rahmendatei","GROUP",5,30,106,35
FF_AddControl "MFDL-Rahmen","flag_Hinzu","BOOL",10,40,8,8
FF_AddControl "MFDL-Rahmen","Rahmen hinzufgen aus Datei","STATIC",22,39,74,10
FF_AddControl "MFDL-Rahmen","RDatei2","SLEDIT",10,51,85,10
FF_SetControlStyle "MFDL-Rahmen","RDatei2",2048
FF_AddControl "MFDL-Rahmen","...","BUTTON",97,51,10,10
FF_AddControl "MFDL-Rahmen","Fortschritt","PROGRESS",5,69,61,4
FF_AddControl "MFDL-Rahmen","?","BUTTON",5,77,11,11
FF_AddControl "MFDL-Rahmen","|","STATIC",20,77,16,10
FF_SetControlStyle "MFDL-Rahmen","|",1
FF_AddControl "MFDL-Rahmen","Update","BUTTON",40,77,26,11
FF_AddControl "MFDL-Rahmen","Start","BUTTON",82,74,26,11
FF_AddControl "MFDL-Rahmen","&delete","BUTTON",2,2,1,1
'** End Dialog MFDL-Rahmen **

call RegistryLesen

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "MFDL-Rahmen","...","Auswahl der hinzu zu fgenden Rahmendatei"
	FF_SetControlTooltip "MFDL-Rahmen","?","Kurzbeschreibung"
	FF_SetControlTooltip "MFDL-Rahmen","Update","Versionskontrolle auf Aktualitt"
	FF_SetControlTooltip "MFDL-Rahmen","Start","Durchfhrung der gewhlten Aktionen"
end if

FF_ActivateControl "MFDL-Rahmen","&delete"
FF_SetDialogTimer "MFDL-Rahmen", 100

do
	Abbruch = false
	
	'Tooltips
	if Version_OK("3.30.06") then
		FF_SetControlTooltip "MFDL-Rahmen","RDatei2",RDatei2
	end if
	
	Select Case FF_ShowDialog ("MFDL-Rahmen")

	Case "TIMER"
		FF_SetControl "MFDL-Rahmen" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "MFDL-Rahmen", 0
	Case "..."
		FF_SetCurrentPath FF_GetScriptPath
		Zieldatei = FF_EnterFileName(true,"*.cfg;*.txt")
		if len(Zieldatei) > 0 then RDatei2 = Zieldatei
		FF_SetControl "MFDL-Rahmen" ,"RDatei2",RDatei2
	Case "Start"
		call WerteAuslesen
		if flag_Sortieren = 0 and flag_Hinzu = 0 then
			msgbox "Eine der Funktionen 'Sortieren' oder 'Hinzufgen'" & vbNewLine & _
				   "muss aktiviert sein!",vbExclamation,"Hinweis"
			Abbruch = true
		end if
		if not Abbruch then
			if flag_Hinzu = 1 then
				call Hinzufuegen
			end if
			if not Abbruch and flag_Sortieren = 1 then call Sortieren
		end if
		exit do
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "?"
		'FF_SetControl "ScalePrint","Fortschritt",65	'############## nur fr Screenshot
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "CANCEL"
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("MFDL-Rahmen")
if SkriptKill then	'ggf. Skript komplett entfernen
	call KillSkript
end if

End Sub
'-------------------------------------------------------------------------
Sub Sortieren
Dim SortText,tAnf,tEnd

tAnf = Timer

call Vorbereitung
if Abbruch then exit sub

Call QuickSort(0, UBound(ListenArray))

call Rekonstruktion
Ergebnis = join(ListenArray,BZ)

Set SortText = objFS.OpenTextFile(Quelldatei,ForWriting, True)
SortText.Write Ergebnis
SortText.Close

tEnd = Timer
if ZeitTest then msgbox "Das Sortieren dauerte " & round(tEnd - tAnf,2) & " sec.",vbInformation,"Info"
msgbox "Es wurden " & Max +1 & " Rahmen sortiert.",vbInformation,"Info"

 
End Sub
'-------------------------------------------------------------------------
Sub Vorbereitung
Dim RahmenText,Text,n,UL,ULn

if not objFS.FileExists(Quelldatei) then
	msgbox "Die Rahmendatei" & vbNewLine & Quelldatei & vbNewLine & "existiert nicht!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

Set RahmenText = objFS.OpenTextFile(Quelldatei, ForReading)
Text = RahmenText.ReadAll
RahmenText.Close

'### Kontrolle der Rahmendatei
if len(Text) = 0 or instr(Text,"#") = 0 then
	msgbox "Es sind keine Rahmen vorhanden!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

if instr(Text,EZ) > 0 then
	msgbox "Der Rahmentext beinhaltet das Zeichen " & EZ & vbNewLine & _
		   "was nicht erlaubt ist!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

if instr(Text,TZ) > 0 then
	msgbox "Der Rahmentext beinhaltet das Zeichen " & TZ & vbNewLine & _
		   "was nicht erlaubt ist!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

'### Backup anlegen
if not ZeitTest then
msgbox "Vor dem Sortieren wird von der Rahmendateiei 'MFDL.cfg'" & vbNewLine & _
	   "im Skriptverzeichnis von FixFoto eine Backupdatei" & vbNewLine & _
	   "'MFDL_Backup' erzeugt und dort abgespeichert!",vbInformation,"Hinweis"

Set RahmenText = objFS.OpenTextFile(BackUpDatei,ForWriting, True)
RahmenText.Write Text
RahmenText.Close
end if

'### Sortieren beginnen
Text = mid(Replace(Text,vbNewLine,EZ),2)		'vbNewline ersetzen durch Konstante EZ
if right(Text,1) <> EZ then Text = Text & EZ	'sicher stellen das Textende ein Zeilenwechsel steht
UrListenArray = split(Text,BZ) 					'Sicherung des Ursprungs in einem Array
Text = ucase(Text)								'Text in Grobuchstaben wandeln
ListenArray = split(Text,BZ)					'Texte zur Sortierung eintragen in ein Array 
Max = UBound(ListenArray)						'oberer Grenzwert der Arrays

'### Umlautkorrektur fr das erste Zeichen
for n = 0 to Max

	UL = left(ListenArray(n),1)
	if instr("",UL) > 0 then
		select case UL
			case "" : ULn = "Ae"
			case "" : ULn = "Oe"
			case "" : ULn = "Ue"
		case else
		end select
		ListenArray(n) = ULn & mid(ListenArray(n),2) & TZ & UL
	end if
next

End Sub
'------------------------------------------------------------------------
Sub Rekonstruktion
Dim n,pos,element

'### Umlaute wieder zurck setzen
for n = 0 to Max
	pos = instr(ListenArray(n),TZ)
	if pos > 0 then
		ListenArray(n) = right(ListenArray(n),1) & mid(ListenArray(n),3,pos -3)
	end if
	
	'### ursprngliche Gro- und Kleinschreibung wieder herstellen
	for each element in UrListenArray
		if ListenArray(n) = ucase(element) then ListenArray(n) = element :	exit for
	next
	
	'### Zeilenumbrche wieder herstellen
	ListenArray(n) = Replace(ListenArray(n),EZ,vbNewLine)
	if n = 0 then ListenArray(n) = BZ & ListenArray(n)
next

End Sub
'------------------------------------------------------------------------
Sub QuickSort(ByVal LB, ByVal UB)
'### Sortieren des Arrays 'ListenArray' nach ASCII-Werten
Dim P1, P2, Ref, TEMP,FS
	
	FS = FS + 1
    P1 = LB
    P2 = UB
    Ref = ListenArray((P1 + P2) / 2)
    
    Do
        Do While ListenArray(P1) < Ref
            P1 = P1 + 1
        Loop
 
        Do While ListenArray(P2) > Ref
            P2 = P2 - 1
        Loop

        If P1 <= P2 Then
            TEMP = ListenArray(P1)
            ListenArray(P1) = ListenArray(P2)
            ListenArray(P2) = TEMP
           
            P1 = P1 + 1
            P2 = P2 - 1
        End If
    Loop Until P1 > P2

    If LB < P2 Then Call QuickSort(LB, P2)
    If P1 < UB Then Call QuickSort(P1, UB)

End Sub
'------------------------------------------------------------------------
Sub Hinzufuegen
'aus der 2. Rahmendatei (RDatei2) werden Rahmen der 1.Rahmendatei (Quelldatei) hinzugefgt
Dim Text,RahmenText,Text2,ZusatzText,msg

if Quelldatei = RDatei2 then
	msgbox "Die Rahmendatei darf nicht die gleiche sein" & vbNewLine & "wie die Quelldatei 'MFDL.cfg'!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if	
	
if not objFS.FileExists(Quelldatei) then
	msgbox "Die Rahmendatei" & vbNewLine & Quelldatei & vbNewLine & "existiert nicht!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

if not objFS.FileExists(RDatei2) then
	msgbox "Die Rahmendatei" & vbNewLine & RDatei2 & vbNewLine & "existiert nicht!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

Set ZusatzText = objFS.OpenTextFile(RDatei2, ForReading)
Text2 = ZusatzText.ReadAll
ZusatzText.Close

if len(Text2) = 0 or instr(Text2,"#") = 0 then
	msgbox "In der der Rahmendatei" & vbNewLine & RDatei2 & vbNewLine & _
		   "sind keine Rahmen vorhanden!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

Antwort = msgbox("Sollen wirklich die Rahmen aus der Datei" & vbNewLine & _
				 RDatei2 & vbNewLine & _
				 "den Rahmen in der Originaldatei 'MFDL.cfg' hinzugefgt werden?",vbQuestion + vbYesNo,"Sicherheitsabfrage")
if Antwort = vbNo then Abbruch = true : exit sub

if right(Text2,2) <> vbNewLine then Text2 = Text2 & vbNewLine 'sicher stellen, dass Zusatztext mit vbNewLine endet


'### Hinzufgen
'keine Leerzeile am Ende der Quelldatei ????
Set RahmenText = objFS.OpenTextFile(Quelldatei, ForAppending)
RahmenText.Write Text2
RahmenText.Close

msg = "Es wurde der Inhalt der Datei" & vbNewLine & RDatei2 & vbNewLine & _
      "der Rahmendatei"  & vbNewLine & Quelldatei & vbNewLine & "hinzugefgt."
if flag_Sortieren = 1 then
	msg = msg & vbNewLine & vbNewLine & "Jetzt werden noch alle Rahmen sortiert!"
end if

msgbox msg,vbInformation,"Info"

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim BreiteKB	: BreiteKB = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",BreiteKB,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,BreiteKB,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",BreiteKB/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile, ZZ

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	ZZ = ZZ + 1
	if ZZ > 1000 then msgbox "Fehler in der Kurzbeschreibung! (objFS?)" : exit sub
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad
const RegSchluessel = "\FF_MFDL_Sort\"

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
TempFile = FF_GetScriptPath & "\MFDLSort-ReadMe.txt"		'ReadMe-Datei
if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'TempFile = FF_GetScriptPath & "\BeipackSammlung"	'Ordnerbeispiel
'if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script" & RegSchluessel
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
		Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen
flag_Sortieren = FF_GetProfile (RegSchluessel,"flag_Sortieren")
if flag_Sortieren = "" then flag_Sortieren = 1

flag_Hinzu = FF_GetProfile (RegSchluessel,"flag_Hinzu")
if flag_Hinzu = "" then flag_Hinzu = 0

RDatei2 = FF_GetProfile (RegSchluessel,"RDatei2")
if RDatei2 = "" then RDatei2 = Quelldatei

'### Werte eintragen
FF_SetControl "MFDL-Rahmen","flag_Sortieren",flag_Sortieren
FF_SetControl "MFDL-Rahmen","flag_Hinzu",flag_Hinzu
FF_SetControl "MFDL-Rahmen","RDatei2",RDatei2

End Sub
'---------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call WerteAuslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"flag_Sortieren",flag_Sortieren
FF_WriteProfile RegSchluessel,"flag_Hinzu",flag_Hinzu
FF_WriteProfile RegSchluessel,"RDatei2",RDatei2

End Sub
'------------------------------------------------------------------------
Sub WerteAuslesen

flag_Sortieren = FF_GetControl ("MFDL-Rahmen","flag_Sortieren")
flag_Hinzu = FF_GetControl ("MFDL-Rahmen","flag_Hinzu")
RDatei2 = FF_GetControl ("MFDL-Rahmen","RDatei2")
 
End Sub
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
